// JS client for gnugo output parsing
// TODO: block user input during COM move
var showBoardParsing = false;
var showBoardParsingRowIndex = 0;
var awaitValidResponse = false;
var awaitFinalScoreResponse = false;
// 連続パスのカウント
var passCount = 0;
var boardSize = 19;
var gameFinish = false;

var gameReady = false;

// GNUGOの手に動きがあったかどうか
var gnuPassed = true;
function onUserInputValid(){
    console.log("valid response");
    //gnugoSendCommand("showboard");
    awaitValidResponse = false;
    setTimeout(function(){
        // gnugoSendCommand("genmove_white");
        // gnugoSendCommand("showboard");
        goWorker.postMessage("genmove_white");
        goWorker.postMessage("showboard");
    }, 500);
}

function notifyLoadingComplete(){
    var loadingPB = document.getElementById("loadingProgressBar");
    loadingPB.style.width = "100%";
    setTimeout(()=>{
        gameReady = true;
        document.getElementById("progressBarContainer").style.height = "0px";
    }, 1000);
}

var goWorker = new Worker("go_worker.js");
goWorker.onmessage = function(event){
    //parseGnugoStdout(event.data);
    console.log("main thread received: ");
    console.log(event.data);
    var commandType = event.data[0];
    var commandContent = event.data[1];
    if (commandType == 0){
        if (commandContent == "initComplete"){
            notifyLoadingComplete();
        }
    } else {
        parseGnugoStdout(commandContent);
    }
};
goWorker.postMessage("initModule");
function parseFinalScoreResponse(stdoutContent){
    //var finalSCore = parseInt(stdoutContent.slice(2, stdoutContent.length));
    alert(stdoutContent.slice(2, stdoutContent.length));
}
function parseGnugoStdout(stdoutContent){
    //console.log("stdout=" + stdoutContent);
    if (stdoutContent.startsWith("?")){
        awaitValidResponse = false;
        alert("invalid command");
        return;
    }
    if (stdoutContent.startsWith("=")){
        if (awaitFinalScoreResponse){
            parseFinalScoreResponse(stdoutContent);
            awaitFinalScoreResponse = false;
        }
        if (awaitValidResponse){
            onUserInputValid();
        }
    }
    if (stdoutContent.startsWith("   A B C")){
        if (!showBoardParsing){
            console.log("showboard stdout detected");
            console.log(stdoutContent);
            showBoardParsing = true;
            gnuPassed = true;
            showBoardParsingRowIndex = 0;
        } else {
            console.log("showboard stdout finish");
            showBoardParsing = false; 
            if (gnuPassed){
                alert("GNU passed");
                console.log("no move?");
                passCount ++;
                checkGameFinish();
            } else {
                passCount = 0;
            }
            console.log("populating...");
            populateBoardGrid();
        }
        return;
    }
    if (showBoardParsing){
        //console.log("showboard stdout: " + stdoutContent);
        if (!parseShowboardLine(stdoutContent)){
            console.log("terminating showboard read");
            showBoardParsing = false;
            console.log("populating...");
            populateBoardGrid();
        }
        showBoardParsingRowIndex ++;
    }
}
function parseShowboardLine(lineContent){

    var tenDigit = parseInt(lineContent[0]);
    var oneDigit = parseInt(lineContent[1]);
    if (!(tenDigit >= 0) && !(oneDigit >= 0)){
        console.log("could not parse: " + lineContent);
        return false;
    }
    if (tenDigit != true){
        tenDigit = 0;
    }
    var rowIndex = tenDigit * 10 + oneDigit;
    //console.log("parsing: " + lineContent); 
    for(var i=0; i<boardSize; i++){
        var cellContent = lineContent[2 * i + 3];
        var cellGridIndex = boardSize * (boardSize-rowIndex) + i;
        var currentStatus = boardStatus[cellGridIndex];
        if (cellContent == '.' || cellContent == '+'){
            boardStatus[cellGridIndex] = 0;
        } else if (cellContent == "O"){
            //debugger;
            if (currentStatus == 0){
                boardStatus[cellGridIndex] = 4;
                gnuPassed = false;
            } else {
                boardStatus[cellGridIndex] = 2;
            }

        } else if (cellContent == "X"){
            if (currentStatus == 0){
                gnuPassed = false;
                boardStatus[cellGridIndex] = 3;
            } else {
                boardStatus[cellGridIndex] = 1;
            }
        } else {
            console.log("unknown cell status");
            debugger;
        }
    }
       return true;
}
// function gnugoInit(){
//     var gnugoInitSessionFunc = Module.cwrap("jsfunc_initsession", "", []);
//     gnugoInitSessionFunc();
// }
// function gnugoSendCommand(moveCommand){
//     console.log("sending: " + moveCommand);
//     var gnugoProcessCommand = Module.cwrap("jsfunc", "number", ["number", "string"]);
//     var retCode = gnugoProcessCommand(1, moveCommand);
//     console.log("retCode=" + retCode);
//     return retCode;
// }


function checkGameFinish(){
    if (passCount >= 2){
        //alert("game finish!");
        awaitFinalScoreResponse = true;
        //gnugoSendCommand("final_score");
        goWorker.postMessage("final_score");
        passCount = 0;
        gameFinish = true;
    }
}

// document.getElementById("initGnugo").addEventListener("click", function(){
//     console.log("initializing");
//     gnugoInit();
// });
// document.getElementById("genmove_white").addEventListener("click", function(){
//     console.log("genmove");
//     gnugoSendCommand("genmove_white");
//     gnugoSendCommand("showboard");
// });
document.getElementById("passMove").addEventListener("click", function(){
    //gnugoSendCommand("play black pass");
    goWorker.postMessage("play black pass");
    passCount ++;
    //gnugoSendCommand("genmove_white");
    goWorker.postMessage("genmove_white");
    //gnugoSendCommand("showboard");
    goWorker.postMessage("showboard");
    checkGameFinish();
});
document.getElementById("newGame").addEventListener("click", function(){
    if (window.confirm("Start a new game?")){
        location.reload();
    }
});


// ------------------------------------------------ //
 var statusElement = document.getElementById('status');
var progressElement = document.getElementById('progress');
//var spinnerElement = document.getElementById('spinner');

// var Module = {
//     preRun: [],
//     postRun: [],
//     onRuntimeInitialized: function(){
//         var loadingPB = document.getElementById("loadingProgressBar");
//         loadingPB.style.width = "100%";
//         gnugoInit();
//         setTimeout(()=>{
//             gameReady = true;
//             document.getElementById("progressBarContainer").style.height = "0px";
//         }, 1000);
//         //gnugoSendCommand("boardsize " + boardSize);
//     },
//     print: (function() {
//         //var element = document.getElementById('output');
//         //if (element) element.value = ''; // clear browser cache
//         return function(text) {
//             if (arguments.length > 1) text = Array.prototype.slice.call(arguments).join(' ');
//             // These replacements are necessary if you render to raw HTML
//             //text = text.replace(/&/g, "&amp;");
//             //text = text.replace(/</g, "&lt;");
//             //text = text.replace(/>/g, "&gt;");
//             //text = text.replace('\n', '<br>', 'g');
//             //console.log(text);
//             parseGnugoStdout(text);
//             // if (element) {
//             //     element.value += text + "\n";
//             //     element.scrollTop = element.scrollHeight; // focus on bottom
//             // }
//         };
//     })(),
//     printErr: function(text) {
//         if (arguments.length > 1) text = Array.prototype.slice.call(arguments).join(' ');
//         console.error(text);
//     },
//     canvas: (function() {
//         // var canvas = document.getElementById('canvas');

//         // // As a default initial behavior, pop up an alert when webgl context is lost. To make your
//         // // application robust, you may want to override this behavior before shipping!
//         // // See http://www.khronos.org/registry/webgl/specs/latest/1.0/#5.15.2
//         // canvas.addEventListener("webglcontextlost", function(e) { alert('WebGL context lost. You will need to reload the page.'); e.preventDefault(); }, false);

//         // return canvas;
//     })(),
//     setStatus: function(text) {
//         if (!Module.setStatus.last) Module.setStatus.last = { time: Date.now(), text: '' };
//         if (text === Module.setStatus.last.text) return;
//         var m = text.match(/([^(]+)\((\d+(\.\d+)?)\/(\d+)\)/);
//         var now = Date.now();
//         if (m && now - Module.setStatus.last.time < 30) return; // if this is a progress update, skip it if too soon
//         Module.setStatus.last.time = now;
//         Module.setStatus.last.text = text;
//         if (m) {
//             text = m[1];
//             // progressElement.value = parseInt(m[2])*100;
//             // progressElement.max = parseInt(m[4])*100;
//             // progressElement.hidden = false;
//             // spinnerElement.hidden = false;
//         } else {
//             // progressElement.value = null;
//             // progressElement.max = null;
//             // progressElement.hidden = true;
//             // if (!text) spinnerElement.style.display = 'none';
//         }
//         //statusElement.innerHTML = text;
//     },
//     totalDependencies: 0,
//     monitorRunDependencies: function(left) {
//         this.totalDependencies = Math.max(this.totalDependencies, left);
//         Module.setStatus(left ? 'Preparing... (' + (this.totalDependencies-left) + '/' + this.totalDependencies + ')' : 'All downloads complete.');
//     }
// };
// Module.setStatus('Downloading...');
// window.onerror = function(event) {
//     // TODO: do not warn on ok events like simulating an infinite loop or exitStatus
//     Module.setStatus('Exception thrown, see JavaScript console');
//     //spinnerElement.style.display = 'none';
//     Module.setStatus = function(text) {
//         if (text) Module.printErr('[post-exception status] ' + text);
//     };
// };
// var gnugoCommand = "showboard";
// function overridePrompt(){
//     window.prompt = function(){
//         console.log("delaying prompt");
//         //return "showboard";
//         var currentCommand = gnugoCommand;
//         console.log("requesting: ");
//         //console.log(gnugoCommand);
//         //if (currentCommand.
//         /* while(gnugoCommand == "showboard"){
//         * } */
//         if (gnugoCommand.startsWith("play")){
//             gnugoCommand = "genmove_white";
//         } else if (gnugoCommand.startsWith("genmove")){
//             gnugoCommand = "showboard";
//         } else {
//             gnugoCommand = "showboard";
//         }
//         /* var startTime = Date.now();
//         * while((Date.now()-startTime) <= 1000){
//         * } */
//         //console.log("delayed");
//         console.log("sending command: " + currentCommand);
//         return currentCommand;
//     }
// }
var boardStatus = new Array();
for(var i=0; i<boardSize *boardSize; i++){
    boardStatus.push(0);
}

function colIndexToLetter(colIndex){
    // 行番号はIを飛ばす
    // A B C D ... G H J K L ... 
    if (colIndex < 8){
        return String.fromCharCode(colIndex+64+1);
    } else {
        return String.fromCharCode(colIndex+64+2);
    }
}
var userColor = 1;
function onUserClicked(positionIndex){
    if (gameFinish){
        if (window.confirm("Start a new game?")){
            location.reload();
        }
        return;
    }
    //console.log("click at " + positionIndex);
    passCount = 0;
    console.log(positionIndex);
    awaitValidResponse = true;
    var colIndex = positionIndex % boardSize;
    var rowIndex = (positionIndex-colIndex)/boardSize;
    var colIndexLetter = colIndexToLetter(colIndex);
    //gnugoSendCommand("play black " + colIndexLetter + (boardSize-rowIndex));
    goWorker.postMessage("play black " + colIndexLetter + (boardSize-rowIndex));
    //gnugoSendCommand("showboard");
    goWorker.postMessage("showboard");
    /* gnugoCommand = "play black d3";
    * console.log("next command: " + gnugoCommand);
    * if (boardStatus[positionIndex] == 0){
    *     boardStatus[positionIndex] = userColor;
    * } else if (boardStatus[positionIndex] == userColor){
    *     alert("ここに石は置けません");
    * } else {
    *     //alert("相手の石を取りますか?");
    *     boardStatus[positionIndex] = 0;
    * } */
    populateBoardGrid();
}
function shouldUseDottedBackground(gridPosition){
    var gridX = gridPosition % boardSize;
    var gridY = (gridPosition-gridX)/boardSize;
    if (gridX == 3 || gridX == 15){
        if (gridY == 3 || gridY == 9 || gridY == 15){
            return true;
        }
    }
    if (gridX == 9){
        if (gridY == 3  || gridY == 15){return true;}
    }
    return false;
}

function populateBoardGrid(){
    var gridParent = document.getElementById("gridContainerGo");
    gridParent.innerHTML = "";
    for(var i=0; i<boardSize * boardSize; i++){
        var gridCell = document.createElement("div");
        if (shouldUseDottedBackground(i)){
            gridCell.className = "dot-foreground";
        } else {
            gridCell.className = "plain-foreground";
        }
        gridCell.id = i;
        /* if (boardStatus[i] == 0){
        *     //gridCell.className = "plain-foreground empty";
        * } */
        //gridCell.innerHTML = "<p>" + i + "</p>";
        if (boardStatus[i] > 0){
            var imageFrame = document.createElement("span");
            imageFrame.className = "stoneImage";
            if (boardStatus[i] == 1){
                imageFrame.innerHTML = "<img class='stoneImage' src='images/black_circle.png'>";
            } else if (boardStatus[i] == 2){
                imageFrame.innerHTML = "<img class='stoneImage' src='images/white_circle.png'>";
            } else if (boardStatus[i] == 3){
                imageFrame.innerHTML = "<img class='stoneImage' src='images/black_circle_new.png'>";
            } else if (boardStatus[i] == 4){
                imageFrame.innerHTML = "<img class='stoneImage' src='images/white_circle_new.png'>";
            }
            gridCell.appendChild(imageFrame);
        }
        gridParent.appendChild(gridCell);

    }

    for(var i=0; i<boardSize * boardSize; i++){
        document.getElementById(i).addEventListener("click", function(e){
            if (!gameReady){
                alert("please wait");
                return;
            }
            console.log("click");
            if (!(e.target.id >= 0)){
                console.log("move not possible");
                return;
            }
            console.log(e.target.id);
            onUserClicked(e.target.id);
        });
    }
}
//boardStatus[10] = 2;
//boardStatus[9] = 1;
populateBoardGrid();
//gnugoInit();
var currentLevel = 10;
for(var i=7; i<=13; i++){
    var levelButton = document.getElementById("level" + String(i));
    levelButton.addEventListener("click", function(e){
        var buttonId = e.target.id;
        var buttonLevel = parseInt(buttonId.slice(5));
        //console.log(buttonLevel);
        currentLevel = buttonLevel;
        //gnugoSendCommand("level " + String(buttonLevel));
        goWorker.postMessage("level " + String(buttonLevel));
        document.getElementById("currentLevel").innerText = String(currentLevel);
    });
}
const canvas = document.getElementById("gridCanvas");
const ctx = canvas.getContext("2d");
ctx.strokeStyle="black";
ctx.lineWidth = 1;
function drawLine(x1,y1,x2,y2){
    ctx.beginPath();
    ctx.moveTo(x1, y1);
    ctx.lineTo(x2, y2);
    ctx.closePath();
}
var gridWidth = canvas.width/19;
var gridHeight = canvas.height/19;
for(var i=0; i<19; i++){
    drawLine(
        gridWidth*0.5, gridHeight*(0.5 + i),
        gridWidth * 18.5,
        gridHeight * (0.5 + i)
    );
    ctx.stroke();
    drawLine(
        gridWidth * (0.5 + i),
        gridHeight * 0.5,
        gridWidth * (0.5 + i),
        gridHeight * 18.5
    );
    ctx.stroke();
}
