//const licensesDict = FILL_LICENSES;

class LicenseRow extends React.Component{
    constructor(props){
        super(props);
        this.state = {
            "name": props.name,
            "version": props.version,
            "license": props.license,
            "licenseText": props.licenseText,
            "url": props.url
        }
        this.shouldShowLicense = props.shouldShowLicense;
    }
    render(){
        return (
            <tr>
                <td>
                    <a href={this.state.url}>
                        {this.state.name}
                    </a>
                </td>
                <td>{this.state.version}</td>
                <td
                    className="hover"
                    onClick={()=>{
                    this.shouldShowLicense(this.state.licenseText);
                    }}>
                    <a href="#">
                        {this.state.license}</a></td>
            </tr>
        );
    }
}


class Acknowledgements extends React.Component{
    constructor(props){
        super(props);
        this.state = {
            "licenseText": ""
        };
    }
    render(){
        var rows = [];
        for(var licenseKey in licensesDict){
            var licenseDict = licensesDict[licenseKey];
            // ignore my package
            if (licenseDict["name"] === "game-board")continue;
            rows.push(<LicenseRow
                          name={licenseDict["name"]}
                          version={licenseDict["version"]}
                          licenseText={licenseDict["licenseText"]}
                          license={licenseDict["licenses"]}
                          url={licenseDict["url"]}
                          shouldShowLicense={(licenseText)=>{
                              this.setState({
                                  "licenseText": licenseText
                              });
                          }}
            />);
        }
        return (
            <div className="row">
                <div className="col-md-6">
                    <table className="table table-bordered">
                        <thead>
                            <th>Library</th>
                            <th>Version</th>
                            <th>License</th>
                        </thead>
                        <tbody>
                            {rows}
                        </tbody>
                    </table>
                </div>
                <div className="col-md-6 text-secondary" style={{
                    "white-space": "pre-line",
                }}>
                    <p>{this.state.licenseText}</p>
                </div>
            </div>
        );
    }
}
