(function (root, factory) {
  if (typeof define === 'function' && define.amd)
    define(['exports', 'kotlin'], factory);
  else if (typeof exports === 'object')
    factory(module.exports, require('kotlin'));
  else {
    if (typeof kotlin === 'undefined') {
      throw new Error("Error loading module 'ktjs-gomoku'. Its dependency 'kotlin' was not found. Please, check whether 'kotlin' is loaded prior to 'ktjs-gomoku'.");
    }
    root['ktjs-gomoku'] = factory(typeof this['ktjs-gomoku'] === 'undefined' ? {} : this['ktjs-gomoku'], kotlin);
  }
}(this, function (_, Kotlin) {
  'use strict';
  var Kind_CLASS = Kotlin.Kind.CLASS;
  var equals = Kotlin.equals;
  var Unit = Kotlin.kotlin.Unit;
  var throwCCE = Kotlin.throwCCE;
  var ArrayList_init = Kotlin.kotlin.collections.ArrayList_init_287e2$;
  var RuntimeException_init = Kotlin.kotlin.RuntimeException_init_pdl1vj$;
  var joinToString = Kotlin.kotlin.collections.joinToString_fmv235$;
  var ArrayList_init_0 = Kotlin.kotlin.collections.ArrayList_init_mqih57$;
  var copyOf = Kotlin.kotlin.collections.copyOf_l1lu5t$;
  var HashMap_init = Kotlin.kotlin.collections.HashMap_init_q3lmfv$;
  var ensureNotNull = Kotlin.ensureNotNull;
  var Kind_OBJECT = Kotlin.Kind.OBJECT;
  var sum = Kotlin.kotlin.collections.sum_tmsbgo$;
  var kotlin_js_internal_DoubleCompanionObject = Kotlin.kotlin.js.internal.DoubleCompanionObject;
  var until = Kotlin.kotlin.ranges.until_dqglrj$;
  var Random = Kotlin.kotlin.random.Random;
  var Math_0 = Math;
  var random = Kotlin.kotlin.ranges.random_xmiyix$;
  var log = Kotlin.kotlin.math.log_lu1900$;
  var pageController;
  var userInputReady;
  function App() {
  }
  Object.defineProperty(App.prototype, 'greeting', {
    get: function () {
      return 'Hello world.';
    }
  });
  App.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'App',
    interfaces: []
  };
  function requestCOMMoveUpdate() {
    var boardState = getBoardState();
  }
  function main(args) {
    populateGoBoardHTML(pageController.main());
    hookUserClickOnBoard();
    hookNewGameButton();
  }
  function populateGoBoardHTML(gameStatus) {
    var tmp$, tmp$_0, tmp$_1, tmp$_2, tmp$_3, tmp$_4;
    var gridHTML = {v: ''};
    for (var gridIndex = 0; gridIndex < 225; gridIndex++) {
      var gridClass = gameStatus.gridCells.get_za3lpa$(gridIndex).gridClass;
      if (equals(gridClass, 'emptyCell')) {
        tmp$ = null;
      }
       else if (equals(gridClass, 'blackCell')) {
        tmp$ = 'images/black_circle.png';
      }
       else if (equals(gridClass, 'whiteCell')) {
        tmp$ = 'images/white_circle.png';
      }
       else {
        tmp$ = null;
      }
      var stoneImage = tmp$;
      gridHTML.v += "<div id='" + gridIndex + "' class='" + gridClass + "'>";
      if (stoneImage != null) {
        gridHTML.v += "  <span class='stoneImageFrame'>";
        gridHTML.v += "    <img class='stoneImage' src='" + stoneImage + "' alt='" + gridClass + "'>";
        gridHTML.v += '  <\/span>';
      }
      gridHTML.v += '<\/div>';
    }
    (Kotlin.isType(tmp$_0 = document.getElementById('gridContainer'), HTMLElement) ? tmp$_0 : throwCCE()).innerHTML = gridHTML.v;
    tmp$_3 = (Kotlin.isType(tmp$_2 = document.getElementById('blackTurn'), HTMLElement) ? tmp$_2 : throwCCE()).style;
    if (userInputReady) {
      tmp$_1 = 'block';
    }
     else {
      tmp$_1 = 'none';
    }
    tmp$_3.display = tmp$_1;
    (Kotlin.isType(tmp$_4 = document.getElementById('gameStatusNotification'), HTMLElement) ? tmp$_4 : throwCCE()).innerHTML = getGameStatusNotificationHTMLContent(gameStatus);
  }
  function getGameStatusNotificationHTMLContent(gameStatus) {
    var tmp$, tmp$_0;
    if ((tmp$ = gameStatus.gameFinishMessage) != null) {
      var htmlContent = '';
      htmlContent = "<div class='alert alert-info col-md-12' id='gameFinishNotification'>";
      htmlContent += tmp$ + "&nbsp;&nbsp;<a href='#' class='newGameButton alert-link'>\u65B0\u3057\u3044\u30B2\u30FC\u30E0\u3092\u958B\u59CB<\/a>";
      htmlContent += '<\/div>';
      return htmlContent;
    }
    if ((tmp$_0 = gameStatus.invalidMoveMessage) != null) {
      var htmlContent_0 = '';
      htmlContent_0 += "<div class='alert alert-warning col-md-12' id='moveNotValidNotification'>";
      htmlContent_0 += tmp$_0;
      htmlContent_0 += '<\/div>';
      return htmlContent_0;
    }
    return '';
  }
  function hookUserClickOnBoard$lambda$lambda$lambda(closure$boardState, closure$gridIndex, closure$resolve) {
    return function () {
      var comStatus = pageController.getCOMBoardStatus_bm4lxs$(closure$boardState, closure$gridIndex);
      closure$resolve(comStatus);
      return Unit;
    };
  }
  function hookUserClickOnBoard$lambda$lambda(closure$boardState, closure$gridIndex) {
    return function (resolve, reject) {
      window.setTimeout(hookUserClickOnBoard$lambda$lambda$lambda(closure$boardState, closure$gridIndex, resolve), 500);
      return Unit;
    };
  }
  function hookUserClickOnBoard$lambda$lambda_0(resultValue) {
    userInputReady = true;
    populateGoBoardHTML(resultValue);
    hookUserClickOnBoard();
    hookNewGameButton();
    return Unit;
  }
  function hookUserClickOnBoard$lambda(closure$gridIndex) {
    return function (event) {
      var tmp$;
      if (document.getElementById('gameFinishNotification') != null) {
        window.alert('\u30B2\u30FC\u30E0\u306F\u7D42\u308F\u3063\u3066\u3044\u307E\u3059');
      }
       else if (!userInputReady) {
        window.alert('\u767D\u306E\u624B\u756A\u3067\u3059');
      }
       else if ((Kotlin.isType(tmp$ = document.getElementById(closure$gridIndex.toString()), HTMLElement) ? tmp$ : throwCCE()).classList.contains('emptyCell'))
        if (userInputReady) {
          userInputReady = false;
          var newGameStatus = pageController.getBoardStatus_19mbxw$(closure$gridIndex, getBoardState());
          populateGoBoardHTML(newGameStatus);
          hookNewGameButton();
          if (newGameStatus.gameFinishMessage == null)
            if (newGameStatus.invalidMoveMessage != null) {
              userInputReady = true;
              hookEvents();
            }
             else {
              var boardState = getBoardState();
              var comMove = new Promise(hookUserClickOnBoard$lambda$lambda(boardState, closure$gridIndex));
              comMove.then(hookUserClickOnBoard$lambda$lambda_0);
            }
        }
      return Unit;
    };
  }
  function hookUserClickOnBoard() {
    var tmp$;
    for (var gridIndex = 0; gridIndex < 225; gridIndex++) {
      (Kotlin.isType(tmp$ = document.getElementById(gridIndex.toString()), HTMLElement) ? tmp$ : throwCCE()).addEventListener('click', hookUserClickOnBoard$lambda(gridIndex));
    }
  }
  function hookEvents() {
    hookUserClickOnBoard();
    hookNewGameButton();
  }
  function hookNewGameButton$lambda(it) {
    var newGameBoardState = pageController.getNewGame();
    populateGoBoardHTML(newGameBoardState);
    userInputReady = true;
    hookEvents();
    return Unit;
  }
  function hookNewGameButton() {
    var tmp$;
    var newgameButtons = Kotlin.isType(tmp$ = document.getElementsByClassName('newGameButton'), HTMLCollection) ? tmp$ : throwCCE();
    var objectIndex = 0;
    while (true) {
      var buttonItem = newgameButtons.item(objectIndex);
      if (buttonItem == null) {
        break;
      }
       else {
        buttonItem.addEventListener('click', hookNewGameButton$lambda);
        objectIndex = objectIndex + 1 | 0;
      }
    }
  }
  function getBoardState() {
    var tmp$;
    var gridStatus = ArrayList_init();
    for (var gridIndex = 0; gridIndex < 225; gridIndex++) {
      var gridObject = Kotlin.isType(tmp$ = document.getElementById(gridIndex.toString()), HTMLElement) ? tmp$ : throwCCE();
      if (gridObject.classList.contains('emptyCell')) {
        gridStatus.add_11rb$('e');
      }
       else if (gridObject.classList.contains('blackCell')) {
        gridStatus.add_11rb$('b');
      }
       else if (gridObject.classList.contains('whiteCell')) {
        gridStatus.add_11rb$('w');
      }
       else {
        throw RuntimeException_init('??');
      }
    }
    return joinToString(gridStatus, '');
  }
  function GameController(boardSize, winSequenceCount) {
    GameController$Companion_getInstance();
    this.boardSize = boardSize;
    this.winSequenceCount = winSequenceCount;
    this.gameBoardStates = HashMap_init();
    this.whiteBoard = Kotlin.booleanArray(Kotlin.imul(this.boardSize, this.boardSize));
    this.blackBoard = Kotlin.booleanArray(Kotlin.imul(this.boardSize, this.boardSize));
    this.stonePositionHistory = ArrayList_init();
    this.scoring = new GameScoring(this.boardSize, this.winSequenceCount);
  }
  GameController.prototype.exploreMove_za3lpa$ = function (player) {
    return this.exploreMove_0(this.whiteBoard, this.blackBoard, this.stonePositionHistory, player);
  };
  GameController.prototype.isGameOver = function () {
    if (this.scoring.gameDraw_nygsz4$(this.whiteBoard, this.blackBoard)) {
      return true;
    }
    if (this.scoring.checkWin_wr9i4e$(this.whiteBoard)) {
      return true;
    }
    if (this.scoring.checkWin_wr9i4e$(this.blackBoard)) {
      return true;
    }
    return false;
  };
  GameController.prototype.exploreMove_0 = function (whiteBoard, blackBoard, stoneHistory, player) {
    var lastStonePosition = stoneHistory.get_za3lpa$(stoneHistory.size - 1 | 0);
    if (player === -1) {
      if (this.scoring.checkLose_brzjni$(blackBoard, whiteBoard, lastStonePosition)) {
        return -1.0;
      }
      if (this.scoring.checkWin_wr9i4e$(blackBoard)) {
        return 1.0;
      }
    }
     else if (player === 1) {
      if (this.scoring.checkLose_brzjni$(whiteBoard, blackBoard, lastStonePosition)) {
        return 1.0;
      }
      if (this.scoring.checkWin_wr9i4e$(whiteBoard)) {
        return -1.0;
      }
    }
    if (this.scoring.gameDraw_nygsz4$(blackBoard, whiteBoard)) {
      return 0.0;
    }
    var gomokuBoard = this.getBoardState_e5jm6p$(stoneHistory);
    var nextPosition = gomokuBoard.selectMove_za3lpa$(player);
    var nextWhiteBoard = this.copyBooleanArray_wr9i4e$(whiteBoard);
    var nextBlackBoard = this.copyBooleanArray_wr9i4e$(blackBoard);
    if (nextWhiteBoard[nextPosition]) {
      throw RuntimeException_init('board not empty');
    }
     else if (nextBlackBoard[nextPosition]) {
      throw RuntimeException_init('board not empty');
    }
    if (player === -1) {
      nextWhiteBoard[nextPosition] = true;
    }
     else if (player === 1) {
      nextBlackBoard[nextPosition] = true;
    }
    var nextStoneHistory = ArrayList_init_0(stoneHistory);
    nextStoneHistory.add_11rb$(nextPosition);
    var nextExplore = this.exploreMove_0(nextWhiteBoard, nextBlackBoard, nextStoneHistory, gomokuBoard.nextPlayer_za3lpa$(player));
    gomokuBoard.notifyReward_24o109$(nextPosition, nextExplore);
    return nextExplore;
  };
  GameController.prototype.copyBooleanArray_wr9i4e$ = function (board) {
    return copyOf(board);
  };
  GameController.prototype.removeStatesWithPreviousHistories = function () {
    var tmp$, tmp$_0;
    var stateKeys = this.gameBoardStates.keys;
    var removeKeysList = ArrayList_init();
    tmp$ = stateKeys.iterator();
    while (tmp$.hasNext()) {
      var keyHistory = tmp$.next();
      if (keyHistory.size < this.stonePositionHistory.size) {
        removeKeysList.add_11rb$(keyHistory);
      }
    }
    tmp$_0 = removeKeysList.iterator();
    while (tmp$_0.hasNext()) {
      var keyHistory_0 = tmp$_0.next();
      this.gameBoardStates.remove_11rb$(keyHistory_0);
    }
  };
  GameController.prototype.cannotPutBlackStone_vux9f0$ = function (x, y) {
    var positionIndex = x + Kotlin.imul(y, this.boardSize) | 0;
    var tempBlackBoard = copyOf(this.blackBoard);
    var tempWhiteBoard = copyOf(this.whiteBoard);
    tempBlackBoard[positionIndex] = true;
    return this.scoring.checkLose_brzjni$(tempBlackBoard, tempWhiteBoard, positionIndex);
  };
  GameController.prototype.putBlackStone_vux9f0$ = function (x, y) {
    var positionIndex = x + Kotlin.imul(y, this.boardSize) | 0;
    this.blackBoard[positionIndex] = true;
    this.gameBoardStates = HashMap_init();
    this.stonePositionHistory.add_11rb$(positionIndex);
  };
  GameController.prototype.explicitMoveAvailable = function () {
    return this.getBoardState_e5jm6p$(this.stonePositionHistory).selectExplicitMove_fzusl$(-1) >= 0;
  };
  GameController.prototype.doMove = function () {
    var gomokuBoard = this.getBoardState_e5jm6p$(this.stonePositionHistory);
    var nextPositionIndex = gomokuBoard.selectMove_za3lpa$(-1);
    this.whiteBoard[nextPositionIndex] = true;
    this.gameBoardStates = HashMap_init();
    this.stonePositionHistory.add_11rb$(nextPositionIndex);
    return nextPositionIndex;
  };
  GameController.prototype.getBoardState_e5jm6p$ = function (stonePositionHistory) {
    var tmp$;
    if (this.gameBoardStates.containsKey_11rb$(stonePositionHistory)) {
      var cachedState = ensureNotNull(this.gameBoardStates.get_11rb$(stonePositionHistory));
      return cachedState;
    }
    var stateBlackBoard = Kotlin.booleanArray(Kotlin.imul(this.boardSize, this.boardSize));
    var stateWhiteBoard = Kotlin.booleanArray(Kotlin.imul(this.boardSize, this.boardSize));
    tmp$ = stonePositionHistory.size;
    for (var i = 0; i < tmp$; i++) {
      if (i % 2 === 0) {
        stateBlackBoard[stonePositionHistory.get_za3lpa$(i)] = true;
      }
       else {
        stateWhiteBoard[stonePositionHistory.get_za3lpa$(i)] = true;
      }
    }
    var newGomokeBoard = new GomokuBoard(this.boardSize, this.winSequenceCount, stateBlackBoard, stateWhiteBoard, ArrayList_init_0(stonePositionHistory));
    this.gameBoardStates.put_xwzc9p$(stonePositionHistory, newGomokeBoard);
    return newGomokeBoard;
  };
  GameController.prototype.getStoneStatus_vux9f0$ = function (x, y) {
    if (this.whiteBoard[x + Kotlin.imul(y, this.boardSize) | 0]) {
      return 2;
    }
    if (this.blackBoard[x + Kotlin.imul(y, this.boardSize) | 0]) {
      return 1;
    }
    return 0;
  };
  function GameController$Companion() {
    GameController$Companion_instance = this;
    this.STONE_EMPTY = 0;
    this.STONE_BLACK = 1;
    this.STONE_WHITE = 2;
  }
  GameController$Companion.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'Companion',
    interfaces: []
  };
  var GameController$Companion_instance = null;
  function GameController$Companion_getInstance() {
    if (GameController$Companion_instance === null) {
      new GameController$Companion();
    }
    return GameController$Companion_instance;
  }
  GameController.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'GameController',
    interfaces: []
  };
  function GameScoring(boardSize, winSequenceCount) {
    GameScoring$Companion_getInstance();
    this.boardSize = boardSize;
    this.winSequenceCount = winSequenceCount;
  }
  GameScoring.prototype.check33_brzjni$ = function (boardArray, otherPlayerBoard, focusPositionIndex) {
    if (focusPositionIndex === void 0)
      focusPositionIndex = -1;
    var tmp$, tmp$_0, tmp$_1, tmp$_2, tmp$_3, tmp$_4, tmp$_5, tmp$_6, tmp$_7, tmp$_8, tmp$_9, tmp$_10, tmp$_11, tmp$_12;
    var directions = ArrayList_init();
    directions.add_11rb$(new Int32Array([1, 0]));
    directions.add_11rb$(new Int32Array([1, 1]));
    directions.add_11rb$(new Int32Array([0, 1]));
    directions.add_11rb$(new Int32Array([-1, 1]));
    var threeCount = new Int32Array(Kotlin.imul(this.boardSize, this.boardSize));
    tmp$ = this.boardSize;
    for (var x = 0; x < tmp$; x++) {
      tmp$_0 = this.boardSize;
      for (var y = 0; y < tmp$_0; y++) {
        if (boardArray[x + Kotlin.imul(y, this.boardSize) | 0]) {
          var threeConsequtiveCount = 0;
          var positionIndex = x + Kotlin.imul(y, this.boardSize) | 0;
          tmp$_1 = directions.iterator();
          while (tmp$_1.hasNext()) {
            var direction = tmp$_1.next();
            tmp$_2 = this.boardSize;
            tmp$_3 = direction[0];
            tmp$_4 = direction[1];
            if (GameScoring$Companion_getInstance().checkConsequtiveStonesInDirection_1ry1wn$(tmp$_2, boardArray, x, y, tmp$_3, tmp$_4, 3, true, true, 0, otherPlayerBoard)) {
              if (!GameScoring$Companion_getInstance().positionOnBoard_qt1dr2$(x - direction[0] | 0, y - direction[1] | 0, this.boardSize) || !GameScoring$Companion_getInstance().positionOnBoard_qt1dr2$(x + (3 * direction[0] | 0) | 0, y + (3 * direction[1] | 0) | 0, this.boardSize)) {
                continue;
              }
              if (otherPlayerBoard[x - direction[0] + Kotlin.imul(y - direction[1] | 0, this.boardSize) | 0] || otherPlayerBoard[x + (3 * direction[0] | 0) + Kotlin.imul(y + (3 * direction[1] | 0) | 0, this.boardSize) | 0]) {
                continue;
              }
              for (var i = 0; i < 3; i++) {
                var sequenceX = x + Kotlin.imul(i, direction[0]) | 0;
                var sequenceY = y + Kotlin.imul(i, direction[1]) | 0;
                var tmp$_13;
                tmp$_13 = sequenceX + Kotlin.imul(sequenceY, this.boardSize) | 0;
                threeCount[tmp$_13] = threeCount[tmp$_13] + 1 | 0;
              }
            }
             else {
              tmp$_5 = this.boardSize;
              tmp$_6 = direction[0];
              tmp$_7 = direction[1];
              if (GameScoring$Companion_getInstance().checkConsequtiveStonesInDirection_1ry1wn$(tmp$_5, boardArray, x, y, tmp$_6, tmp$_7, 4, true, true, 1, otherPlayerBoard)) {
                tmp$_8 = this.boardSize;
                tmp$_9 = direction[0];
                tmp$_10 = direction[1];
                if (GameScoring$Companion_getInstance().checkConsequtiveStonesInDirection_1ry1wn$(tmp$_8, boardArray, x, y, tmp$_9, tmp$_10, 4, true, true, 0, otherPlayerBoard)) {
                  continue;
                }
                if (!GameScoring$Companion_getInstance().positionOnBoard_qt1dr2$(x - direction[0] | 0, y - direction[1] | 0, this.boardSize) || !GameScoring$Companion_getInstance().positionOnBoard_qt1dr2$(x + (4 * direction[0] | 0) | 0, y + (4 * direction[1] | 0) | 0, this.boardSize)) {
                  continue;
                }
                if (otherPlayerBoard[x - direction[0] + Kotlin.imul(y - direction[1] | 0, this.boardSize) | 0] || otherPlayerBoard[x + (4 * direction[0] | 0) + Kotlin.imul(y + (4 * direction[1] | 0) | 0, this.boardSize) | 0]) {
                  continue;
                }
                for (var i_0 = 0; i_0 < 4; i_0++) {
                  var sequenceX_0 = x + Kotlin.imul(i_0, direction[0]) | 0;
                  var sequenceY_0 = y + Kotlin.imul(i_0, direction[1]) | 0;
                  if (!boardArray[sequenceX_0 + Kotlin.imul(sequenceY_0, this.boardSize) | 0]) {
                    continue;
                  }
                  if (otherPlayerBoard[sequenceX_0 + Kotlin.imul(sequenceY_0, this.boardSize) | 0]) {
                    throw RuntimeException_init('otherboard not empty!');
                  }
                  var tmp$_14;
                  tmp$_14 = sequenceX_0 + Kotlin.imul(sequenceY_0, this.boardSize) | 0;
                  threeCount[tmp$_14] = threeCount[tmp$_14] + 1 | 0;
                }
              }
            }
          }
        }
      }
    }
    if (focusPositionIndex >= 0) {
      return threeCount[focusPositionIndex] >= 2;
    }
    tmp$_11 = this.boardSize;
    for (var x_0 = 0; x_0 < tmp$_11; x_0++) {
      tmp$_12 = this.boardSize;
      for (var y_0 = 0; y_0 < tmp$_12; y_0++) {
        if (threeCount[x_0 + Kotlin.imul(y_0, this.boardSize) | 0] >= 2) {
          return true;
        }
      }
    }
    return false;
  };
  GameScoring.prototype.checkLose_brzjni$ = function (boardArray, otherPlayerBoard, lastStoneIndex) {
    if (this.check33_brzjni$(boardArray, otherPlayerBoard, lastStoneIndex)) {
      return true;
    }
    return false;
  };
  GameScoring.prototype.checkWin_wr9i4e$ = function (boardArray) {
    var tmp$, tmp$_0;
    tmp$ = this.boardSize;
    for (var x = 0; x < tmp$; x++) {
      tmp$_0 = this.boardSize;
      for (var y = 0; y < tmp$_0; y++) {
        if (boardArray[x + Kotlin.imul(y, this.boardSize) | 0]) {
          if (GameScoring$Companion_getInstance().checkConsequtiveStonesInDirection_1ry1wn$(this.boardSize, boardArray, x, y, 1, 0, this.winSequenceCount, true)) {
            return true;
          }
          if (GameScoring$Companion_getInstance().checkConsequtiveStonesInDirection_1ry1wn$(this.boardSize, boardArray, x, y, 1, 1, this.winSequenceCount, true)) {
            return true;
          }
          if (GameScoring$Companion_getInstance().checkConsequtiveStonesInDirection_1ry1wn$(this.boardSize, boardArray, x, y, 0, 1, this.winSequenceCount, true)) {
            return true;
          }
          if (GameScoring$Companion_getInstance().checkConsequtiveStonesInDirection_1ry1wn$(this.boardSize, boardArray, x, y, -1, 1, this.winSequenceCount, true)) {
            return true;
          }
        }
      }
    }
    return false;
  };
  GameScoring.prototype.gameDraw_nygsz4$ = function (whiteBoard, blackBoard) {
    var tmp$;
    tmp$ = Kotlin.imul(this.boardSize, this.boardSize);
    for (var i = 0; i < tmp$; i++) {
      if (!blackBoard[i] && !whiteBoard[i]) {
        return false;
      }
    }
    return true;
  };
  function GameScoring$Companion() {
    GameScoring$Companion_instance = this;
  }
  GameScoring$Companion.prototype.positionOnBoard_qt1dr2$ = function (x, y, boardSize) {
    return x >= 0 && y >= 0 && x < boardSize && y < boardSize;
  };
  GameScoring$Companion.prototype.checkConsequtiveStonesInDirection_1ry1wn$ = function (boardSize, boardArray, startX, startY, directionX, directionY, repeat, checkBedinnning, checkEnd, missingTorelance, otherPlayerBoard) {
    if (checkBedinnning === void 0)
      checkBedinnning = false;
    if (checkEnd === void 0)
      checkEnd = true;
    if (missingTorelance === void 0)
      missingTorelance = 0;
    if (otherPlayerBoard === void 0)
      otherPlayerBoard = null;
    var tmp$;
    if (repeat === 0) {
      if (checkEnd) {
        if (startX >= 0 && startY >= 0 && startX < boardSize && startY < boardSize) {
          if (boardArray[startX + Kotlin.imul(startY, boardSize) | 0]) {
            return false;
          }
           else {
            if (otherPlayerBoard != null) {
              if (otherPlayerBoard[startY + Kotlin.imul(startY, boardSize) | 0]) {
                return false;
              }
            }
            return true;
          }
        }
         else {
          return true;
        }
      }
      return true;
    }
    if (startX >= boardSize || startY >= boardSize || startX < 0 || startY < 0) {
      return false;
    }
    if (checkBedinnning) {
      var previousX = startX - directionX | 0;
      var previousY = startY - directionY | 0;
      if (previousX >= 0 && previousY >= 0 && previousX < boardSize && previousY < boardSize) {
        if (boardArray[previousX + Kotlin.imul(previousY, boardSize) | 0]) {
          return false;
        }
        if (otherPlayerBoard != null) {
          if (otherPlayerBoard[previousX + Kotlin.imul(previousY, boardSize) | 0]) {
            return false;
          }
        }
      }
    }
    if (missingTorelance === 0) {
      if (!boardArray[startX + Kotlin.imul(startY, boardSize) | 0]) {
        tmp$ = false;
      }
       else {
        tmp$ = this.checkConsequtiveStonesInDirection_1ry1wn$(boardSize, boardArray, startX + directionX | 0, startY + directionY | 0, directionX, directionY, repeat - 1 | 0, false, checkEnd);
      }
      return tmp$;
    }
     else {
      if (!boardArray[startX + Kotlin.imul(startY, boardSize) | 0]) {
        if (otherPlayerBoard != null) {
          if (otherPlayerBoard[startX + Kotlin.imul(startY, boardSize) | 0]) {
            return false;
          }
        }
        return this.checkConsequtiveStonesInDirection_1ry1wn$(boardSize, boardArray, startX + directionX | 0, startY + directionY | 0, directionX, directionY, repeat - 1 | 0, false, checkEnd, missingTorelance - 1 | 0, otherPlayerBoard);
      }
       else {
        return this.checkConsequtiveStonesInDirection_1ry1wn$(boardSize, boardArray, startX + directionX | 0, startY + directionY | 0, directionX, directionY, repeat - 1 | 0, false, checkEnd, missingTorelance, otherPlayerBoard);
      }
    }
  };
  GameScoring$Companion.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'Companion',
    interfaces: []
  };
  var GameScoring$Companion_instance = null;
  function GameScoring$Companion_getInstance() {
    if (GameScoring$Companion_instance === null) {
      new GameScoring$Companion();
    }
    return GameScoring$Companion_instance;
  }
  GameScoring.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'GameScoring',
    interfaces: []
  };
  function StoneSequence(startX, startY, directionX, directionY, repeatCount) {
    this.startX = startX;
    this.startY = startY;
    this.directionX = directionX;
    this.directionY = directionY;
    this.repeatCount = repeatCount;
  }
  StoneSequence.prototype.getPositionIndex_za3lpa$ = function (boardSize) {
    return this.startX + Kotlin.imul(boardSize, this.startY) | 0;
  };
  StoneSequence.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'StoneSequence',
    interfaces: []
  };
  function GomokuBoard(boardSize, winSequenceCount, blackBoard, whiteBoard, stonePositionHistory) {
    GomokuBoard$Companion_getInstance();
    this.boardSize = boardSize;
    this.winSequenceCount = winSequenceCount;
    this.blackBoard = blackBoard;
    this.whiteBoard = whiteBoard;
    this.stonePositionHistory = stonePositionHistory;
    this.positionExploredCount = null;
    this.positionExplored = null;
    this.reward = null;
    this.positionEmpty = null;
    this.nearbyOccupied = null;
    this.blackPartialSequence = ArrayList_init();
    this.whitePartialSequence = ArrayList_init();
    this.directions = ArrayList_init();
    this.positionExploredCount = new Int32Array(Kotlin.imul(this.boardSize, this.boardSize));
    this.positionExplored = Kotlin.booleanArray(Kotlin.imul(this.boardSize, this.boardSize));
    this.positionEmpty = Kotlin.booleanArray(Kotlin.imul(this.boardSize, this.boardSize));
    this.nearbyOccupied = Kotlin.booleanArray(Kotlin.imul(this.boardSize, this.boardSize));
    this.reward = new Float32Array(Kotlin.imul(this.boardSize, this.boardSize));
    this.updatePositionEmpty();
    this.directions.add_11rb$(new Int32Array([1, 0]));
    this.directions.add_11rb$(new Int32Array([1, 1]));
    this.directions.add_11rb$(new Int32Array([0, 1]));
    this.directions.add_11rb$(new Int32Array([-1, 1]));
  }
  GomokuBoard.prototype.updatePositionEmpty = function () {
    var tmp$;
    tmp$ = Kotlin.imul(this.boardSize, this.boardSize);
    for (var i = 0; i < tmp$; i++) {
      this.positionEmpty[i] = (!this.blackBoard[i] && !this.whiteBoard[i]);
    }
  };
  GomokuBoard.prototype.initBoard = function () {
    var tmp$, tmp$_0, tmp$_1;
    tmp$ = Kotlin.imul(this.boardSize, this.boardSize);
    for (var i = 0; i < tmp$; i++) {
      if ((tmp$_0 = this.whiteBoard) != null) {
        tmp$_0[i] = false;
      }
      if ((tmp$_1 = this.blackBoard) != null) {
        tmp$_1[i] = false;
      }
    }
  };
  GomokuBoard.prototype.canPutWhiteStone_vux9f0$ = function (x, y) {
    var whiteStatus = this.getWhiteBoardStatus_vux9f0$(x, y);
    var blackStatus = this.getBlackBoardStatus_vux9f0$(x, y);
    if (whiteStatus) {
      return false;
    }
    if (blackStatus) {
      return false;
    }
    return true;
  };
  GomokuBoard.prototype.canPutBlackStone_vux9f0$ = function (x, y) {
    var whiteStatus = this.getWhiteBoardStatus_vux9f0$(x, y);
    var blackStatus = this.getBlackBoardStatus_vux9f0$(x, y);
    if (whiteStatus) {
      return false;
    }
    if (blackStatus) {
      return false;
    }
    return true;
  };
  GomokuBoard.prototype.getWhiteBoardStatus_vux9f0$ = function (x, y) {
    if (x < 0 || y < 0 || x >= this.boardSize || y >= this.boardSize) {
      return false;
    }
    return this.whiteBoard[x + Kotlin.imul(this.boardSize, y) | 0];
  };
  GomokuBoard.prototype.getBlackBoardStatus_vux9f0$ = function (x, y) {
    if (x < 0 || y < 0 || x >= this.boardSize || y >= this.boardSize) {
      return false;
    }
    return this.blackBoard[x + Kotlin.imul(this.boardSize, y) | 0];
  };
  GomokuBoard.prototype.updateExploredBooleanArray = function () {
    var tmp$;
    tmp$ = Kotlin.imul(this.boardSize, this.boardSize);
    for (var i = 0; i < tmp$; i++) {
      this.positionExplored[i] = this.positionExploredCount[i] !== 0;
    }
  };
  GomokuBoard.prototype.updateNearbyOccupied_vux9f0$ = function (newStoneX, newStoneY) {
    var nearbyDistance = 2;
    for (var x = -nearbyDistance | 0; x < nearbyDistance; x++) {
      if ((newStoneX + x | 0) < 0) {
        continue;
      }
      if ((newStoneX + x | 0) >= this.boardSize) {
        break;
      }
      for (var y = -nearbyDistance | 0; y < nearbyDistance; y++) {
        if ((newStoneY + y | 0) < 0) {
          continue;
        }
        if ((newStoneY + y | 0) >= this.boardSize) {
          break;
        }
        var positionIndex1 = newStoneX + x + Kotlin.imul(newStoneY + y | 0, this.boardSize) | 0;
        if (!this.nearbyOccupied[positionIndex1]) {
          this.nearbyOccupied[positionIndex1] = true;
        }
      }
    }
  };
  GomokuBoard.prototype.updateNearbyOccupied = function () {
    var tmp$, tmp$_0;
    tmp$ = this.boardSize;
    for (var x = 0; x < tmp$; x++) {
      tmp$_0 = this.boardSize;
      for (var y = 0; y < tmp$_0; y++) {
        if (!this.isPositionEmpty_za3lpa$(x + Kotlin.imul(y, this.boardSize) | 0)) {
          this.updateNearbyOccupied_vux9f0$(x, y);
        }
      }
    }
  };
  GomokuBoard.prototype.getNumberOfNotExploredPosition = function () {
    var tmp$;
    var count = 0;
    tmp$ = Kotlin.imul(this.boardSize, this.boardSize);
    for (var i = 0; i < tmp$; i++) {
      if (!this.positionEmpty[i]) {
        continue;
      }
      if (!this.nearbyOccupied[i]) {
        continue;
      }
      if (!this.positionExplored[i]) {
        count = count + 1 | 0;
      }
    }
    return count;
  };
  GomokuBoard.prototype.getUCBArray_za3lpa$ = function (player) {
    var tmp$;
    var meanReward = new Float64Array(Kotlin.imul(this.boardSize, this.boardSize));
    var totalCount = sum(this.positionExploredCount);
    tmp$ = Kotlin.imul(this.boardSize, this.boardSize);
    for (var i = 0; i < tmp$; i++) {
      var exploredCount = this.positionExploredCount[i];
      var x = 2.0 * Math$Companion_getInstance().log_14dthe$(totalCount) / exploredCount;
      var u = Math_0.sqrt(x);
      meanReward[i] = this.reward[i] / this.positionExploredCount[i] * player + u;
    }
    return meanReward;
  };
  GomokuBoard.prototype.notifyReward_24o109$ = function (positionIndex, rewardValue) {
    var tmp$;
    tmp$ = this.positionExploredCount;
    tmp$[positionIndex] = tmp$[positionIndex] + 1 | 0;
    this.reward[positionIndex] = this.reward[positionIndex] + rewardValue;
  };
  GomokuBoard.prototype.selectUCB_0 = function (player) {
    var tmp$;
    var meanReward = this.getUCBArray_za3lpa$(player);
    var maxRewardValue = kotlin_js_internal_DoubleCompanionObject.NEGATIVE_INFINITY;
    var maxRewardIndex = -1;
    tmp$ = Kotlin.imul(this.boardSize, this.boardSize);
    for (var i = 0; i < tmp$; i++) {
      if (!this.positionEmpty[i]) {
        continue;
      }
      if (maxRewardValue <= meanReward[i]) {
        maxRewardIndex = i;
        maxRewardValue = meanReward[i];
      }
    }
    if (maxRewardIndex !== -1) {
      TNLog$Companion_getInstance().i_puj7f4$(GomokuBoard$Companion_getInstance().TAG, 'reward for this action=' + maxRewardValue);
      return maxRewardIndex;
    }
     else {
      throw RuntimeException_init('no move possible!');
    }
  };
  GomokuBoard.prototype.nextPlayer_za3lpa$ = function (player) {
    if (player === 1)
      return -1;
    else if (player === -1)
      return 1;
    else
      throw RuntimeException_init('unknown player');
  };
  GomokuBoard.prototype.selectMove_za3lpa$ = function (player) {
    var tmp$;
    this.updatePositionEmpty();
    this.updateExploredBooleanArray();
    this.updateNearbyOccupied();
    var explicitMove = this.selectExplicitMove_fzusl$(player);
    if (explicitMove >= 0) {
      return explicitMove;
    }
    var notExploredCount = this.getNumberOfNotExploredPosition();
    if (notExploredCount === 0) {
      return this.selectUCB_0(player);
    }
     else {
      var randomPositionIndex = random(until(0, notExploredCount), Random.Default);
      var notExploredCount_0 = 0;
      tmp$ = Kotlin.imul(this.boardSize, this.boardSize);
      for (var i = 0; i < tmp$; i++) {
        if (!this.positionEmpty[i]) {
          continue;
        }
        if (!this.nearbyOccupied[i]) {
          continue;
        }
        if (!this.positionExplored[i]) {
          if (notExploredCount_0 === randomPositionIndex) {
            return i;
          }
          notExploredCount_0 = notExploredCount_0 + 1 | 0;
        }
      }
    }
    TNLog$Companion_getInstance().i_puj7f4$(GomokuBoard$Companion_getInstance().TAG, 'could not find random position');
    throw RuntimeException_init('?');
  };
  GomokuBoard.prototype.isPositionEmpty_vux9f0$ = function (x, y) {
    return this.isPositionEmpty_za3lpa$(x + Kotlin.imul(y, this.boardSize) | 0);
  };
  GomokuBoard.prototype.isPositionEmpty_za3lpa$ = function (positionIndex) {
    return !this.whiteBoard[positionIndex] && !this.blackBoard[positionIndex];
  };
  GomokuBoard.prototype.selectCandidateInEmptyPosition_tjonv8$ = function (x1, y1, x2, y2) {
    var candidate1 = -1;
    var candidate2 = -1;
    if (x1 >= 0 && y1 >= 0 && x1 < this.boardSize && y1 < this.boardSize) {
      if (this.isPositionEmpty_za3lpa$(x1 + Kotlin.imul(y1, this.boardSize) | 0)) {
        candidate1 = x1 + Kotlin.imul(y1, this.boardSize) | 0;
      }
    }
    if (x2 >= 0 && y2 >= 0 && x2 < this.boardSize && y2 < this.boardSize) {
      if (this.isPositionEmpty_za3lpa$(x2 + Kotlin.imul(y2, this.boardSize) | 0)) {
        candidate2 = x2 + Kotlin.imul(y2, this.boardSize) | 0;
      }
    }
    return this.selectCandidate_vux9f0$(candidate1, candidate2);
  };
  GomokuBoard.prototype.getBoardArray_za3lpa$ = function (player) {
    var tmp$;
    if (player === -1) {
      tmp$ = this.whiteBoard;
    }
     else if (player === 1) {
      tmp$ = this.blackBoard;
    }
     else {
      throw RuntimeException_init('unknown player');
    }
    return tmp$;
  };
  GomokuBoard.prototype.selectCandidateInBothEmptyPositions_tjonv8$ = function (x1, y1, x2, y2) {
    var tmp$;
    var candidate1 = -1;
    var candidate2 = -1;
    if (x1 >= 0 && y1 >= 0 && x1 < this.boardSize && y1 < this.boardSize) {
      if (this.isPositionEmpty_za3lpa$(x1 + Kotlin.imul(y1, this.boardSize) | 0)) {
        candidate1 = x1 + Kotlin.imul(y1, this.boardSize) | 0;
      }
    }
    if (x2 >= 0 && y2 >= 0 && x2 < this.boardSize && y2 < this.boardSize) {
      if (this.isPositionEmpty_za3lpa$(x2 + Kotlin.imul(y2, this.boardSize) | 0)) {
        candidate2 = x2 + Kotlin.imul(y2, this.boardSize) | 0;
      }
    }
    if (candidate1 >= 0 && candidate2 >= 0) {
      if (Random.Default.nextBoolean()) {
        tmp$ = candidate1;
      }
       else {
        tmp$ = candidate2;
      }
      return tmp$;
    }
    return -1;
  };
  GomokuBoard.prototype.selectCandidate_vux9f0$ = function (candidate1, candidate2) {
    if (candidate1 >= 0 && candidate2 >= 0) {
      if (Random.Default.nextBoolean()) {
        return candidate1;
      }
       else {
        return candidate2;
      }
    }
    if (candidate1 >= 0) {
      return candidate1;
    }
    if (candidate2 >= 0) {
      return candidate2;
    }
    return -1;
  };
  GomokuBoard.prototype.positionOnBoard_vux9f0$ = function (x, y) {
    return x >= 0 && y >= 0 && x < this.boardSize && y < this.boardSize;
  };
  GomokuBoard.prototype.selectSkipCandidateInEmptyPosition_wsqjni$ = function (boardArray, xn1, yn1, x1, y1, xn2, yn2, x2, y2) {
    var candidate1 = -1;
    var candidate2 = -1;
    if (this.positionOnBoard_vux9f0$(xn1, yn1) && this.positionOnBoard_vux9f0$(x1, y1)) {
      if (boardArray[xn1 + Kotlin.imul(yn1, this.boardSize) | 0] && this.isPositionEmpty_vux9f0$(x1, y1)) {
        candidate1 = x1 + Kotlin.imul(y1, this.boardSize) | 0;
      }
    }
    if (this.positionOnBoard_vux9f0$(xn2, yn2) && this.positionOnBoard_vux9f0$(x2, y2)) {
      if (boardArray[xn2 + Kotlin.imul(yn2, this.boardSize) | 0] && this.isPositionEmpty_vux9f0$(x2, y2)) {
        candidate2 = x2 + Kotlin.imul(y2, this.boardSize) | 0;
      }
    }
    return this.selectCandidate_vux9f0$(candidate1, candidate2);
  };
  GomokuBoard.prototype.occupiedOrOutOfBoard_0 = function (x, y, boardArray) {
    if (boardArray === void 0)
      boardArray = null;
    if (x < 0 || y < 0 || x >= this.boardSize || y >= this.boardSize) {
      return true;
    }
    if (boardArray != null) {
      return boardArray[x + Kotlin.imul(y, this.boardSize) | 0];
    }
    return !this.isPositionEmpty_vux9f0$(x, y);
  };
  GomokuBoard.prototype.selectNextReachMove_za3lpa$ = function (player) {
    var tmp$, tmp$_0, tmp$_1;
    var boardArray = this.getBoardArray_za3lpa$(player);
    var otherBoard = this.getBoardArray_za3lpa$(this.nextPlayer_za3lpa$(player));
    tmp$ = this.boardSize;
    for (var x = 0; x < tmp$; x++) {
      tmp$_0 = this.boardSize;
      for (var y = 0; y < tmp$_0; y++) {
        if (boardArray[x + Kotlin.imul(y, this.boardSize) | 0]) {
          tmp$_1 = this.directions.iterator();
          while (tmp$_1.hasNext()) {
            var direction = tmp$_1.next();
            if (GameScoring$Companion_getInstance().checkConsequtiveStonesInDirection_1ry1wn$(this.boardSize, boardArray, x, y, direction[0], direction[1], this.winSequenceCount - 2 | 0, true, true, void 0, otherBoard)) {
              var left1X = x - direction[0] | 0;
              var left1Y = y - direction[1] | 0;
              var left2X = x - (2 * direction[0] | 0) | 0;
              var left2Y = y - (2 * direction[1] | 0) | 0;
              var right1X = x + (3 * direction[0] | 0) | 0;
              var right1Y = y + (3 * direction[1] | 0) | 0;
              var right2X = x + (4 * direction[0] | 0) | 0;
              var right2Y = y + (4 * direction[1] | 0) | 0;
              var candidate1 = -1;
              var candidate2 = -1;
              if (this.occupiedOrOutOfBoard_0(left1X, left1Y) || this.occupiedOrOutOfBoard_0(right1X, right1Y)) {
                return -1;
              }
              if (!this.occupiedOrOutOfBoard_0(left1X, left1Y)) {
                if (!this.occupiedOrOutOfBoard_0(left2X, left2Y, otherBoard)) {
                  candidate1 = left1X + Kotlin.imul(left1Y, this.boardSize) | 0;
                }
              }
              if (!this.occupiedOrOutOfBoard_0(right1X, right1Y)) {
                if (!this.occupiedOrOutOfBoard_0(right2X, right2Y, otherBoard)) {
                  candidate2 = right1X + Kotlin.imul(right1Y, this.boardSize) | 0;
                }
              }
              var candidate = this.selectCandidate_vux9f0$(candidate1, candidate2);
              if (candidate >= 0) {
                return candidate;
              }
            }
          }
        }
      }
    }
    return -1;
  };
  GomokuBoard.prototype.selectNextSkipReachMove_za3lpa$ = function (player) {
    var tmp$, tmp$_0, tmp$_1, tmp$_2;
    var boardArray = this.getBoardArray_za3lpa$(player);
    var otherPlayerArray = this.getBoardArray_za3lpa$(this.nextPlayer_za3lpa$(player));
    tmp$ = this.boardSize;
    for (var x = 0; x < tmp$; x++) {
      tmp$_0 = this.boardSize;
      for (var y = 0; y < tmp$_0; y++) {
        if (boardArray[x + Kotlin.imul(y, this.boardSize) | 0]) {
          tmp$_1 = this.directions.iterator();
          while (tmp$_1.hasNext()) {
            var direction = tmp$_1.next();
            if (GameScoring$Companion_getInstance().checkConsequtiveStonesInDirection_1ry1wn$(this.boardSize, boardArray, x, y, direction[0], direction[1], this.winSequenceCount - 1 | 0, true, true, 1, otherPlayerArray)) {
              tmp$_2 = this.winSequenceCount - 1 | 0;
              for (var i = 0; i < tmp$_2; i++) {
                var sequenceX = x + Kotlin.imul(i, direction[0]) | 0;
                var sequenceY = y + Kotlin.imul(i, direction[1]) | 0;
                var sequencePositionIndex = sequenceX + Kotlin.imul(sequenceY, this.boardSize) | 0;
                if (!boardArray[sequencePositionIndex]) {
                  return sequencePositionIndex;
                }
              }
            }
          }
        }
      }
    }
    return -1;
  };
  GomokuBoard.prototype.selectSkipReachMove_za3lpa$ = function (player) {
    var tmp$, tmp$_0, tmp$_1, tmp$_2;
    var boardArray = this.getBoardArray_za3lpa$(player);
    var otherBoard = this.getBoardArray_za3lpa$(this.nextPlayer_za3lpa$(player));
    tmp$ = this.boardSize;
    for (var x = 0; x < tmp$; x++) {
      tmp$_0 = this.boardSize;
      for (var y = 0; y < tmp$_0; y++) {
        if (boardArray[x + Kotlin.imul(y, this.boardSize) | 0]) {
          tmp$_1 = this.directions.iterator();
          while (tmp$_1.hasNext()) {
            var direction = tmp$_1.next();
            if (GameScoring$Companion_getInstance().checkConsequtiveStonesInDirection_1ry1wn$(this.boardSize, boardArray, x, y, direction[0], direction[1], this.winSequenceCount, true, true, 1)) {
              tmp$_2 = this.winSequenceCount;
              for (var i = 0; i < tmp$_2; i++) {
                var sequenceX = x + Kotlin.imul(i, direction[0]) | 0;
                var sequenceY = y + Kotlin.imul(i, direction[1]) | 0;
                var sequencePositionIndex = sequenceX + Kotlin.imul(sequenceY, this.boardSize) | 0;
                if (!boardArray[sequencePositionIndex]) {
                  if (otherBoard[sequencePositionIndex]) {
                    continue;
                  }
                  return sequencePositionIndex;
                }
              }
            }
          }
        }
      }
    }
    return -1;
  };
  GomokuBoard.prototype.selectReadhMove_za3lpa$ = function (player) {
    var tmp$, tmp$_0, tmp$_1, tmp$_2;
    if (player === -1) {
      tmp$ = this.whiteBoard;
    }
     else if (player === 1) {
      tmp$ = this.blackBoard;
    }
     else {
      throw RuntimeException_init('unknown player');
    }
    var boardArray = tmp$;
    tmp$_0 = this.boardSize;
    for (var x = 0; x < tmp$_0; x++) {
      tmp$_1 = this.boardSize;
      for (var y = 0; y < tmp$_1; y++) {
        if (boardArray[x + Kotlin.imul(y, this.boardSize) | 0]) {
          tmp$_2 = this.directions.iterator();
          while (tmp$_2.hasNext()) {
            var direction = tmp$_2.next();
            if (GameScoring$Companion_getInstance().checkConsequtiveStonesInDirection_1ry1wn$(this.boardSize, boardArray, x, y, direction[0], direction[1], this.winSequenceCount - 1 | 0, true, true)) {
              var candidate = this.selectCandidateInEmptyPosition_tjonv8$(x - direction[0] | 0, y - direction[1] | 0, x + Kotlin.imul(this.winSequenceCount - 1 | 0, direction[0]) | 0, y + Kotlin.imul(this.winSequenceCount - 1 | 0, direction[1]) | 0);
              if (candidate >= 0) {
                return candidate;
              }
            }
          }
        }
      }
    }
    return -1;
  };
  GomokuBoard.prototype.selectExplicitMove_fzusl$ = function (player, checkReverse) {
    if (checkReverse === void 0)
      checkReverse = true;
    var reachMove = this.selectReadhMove_za3lpa$(player);
    if (reachMove >= 0) {
      return reachMove;
    }
    var skipReachMove = this.selectSkipReachMove_za3lpa$(player);
    if (skipReachMove >= 0) {
      return skipReachMove;
    }
    var reverseReachMove = this.selectReadhMove_za3lpa$(this.nextPlayer_za3lpa$(player));
    if (reverseReachMove >= 0 && checkReverse) {
      return reverseReachMove;
    }
    var reverseSkipReachMove = this.selectSkipReachMove_za3lpa$(this.nextPlayer_za3lpa$(player));
    if (reverseSkipReachMove >= 0 && checkReverse) {
      return reverseSkipReachMove;
    }
    var nextReachMove = this.selectNextReachMove_za3lpa$(player);
    if (nextReachMove >= 0) {
      return nextReachMove;
    }
    var nextSkipReachmove = this.selectNextSkipReachMove_za3lpa$(player);
    if (nextSkipReachmove >= 0) {
      return nextSkipReachmove;
    }
    var reverseNextReachMove = this.selectNextReachMove_za3lpa$(this.nextPlayer_za3lpa$(player));
    if (reverseNextReachMove >= 0) {
      return reverseNextReachMove;
    }
    var reverseNextSkipReachMove = this.selectNextSkipReachMove_za3lpa$(this.nextPlayer_za3lpa$(player));
    if (reverseNextSkipReachMove >= 0) {
      return reverseNextSkipReachMove;
    }
    return -1;
  };
  function GomokuBoard$Companion() {
    GomokuBoard$Companion_instance = this;
    this.PLAYER_BLACK = 1;
    this.PLAYER_WHITE = -1;
    this.TAG = 'GoBoard';
  }
  GomokuBoard$Companion.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'Companion',
    interfaces: []
  };
  var GomokuBoard$Companion_instance = null;
  function GomokuBoard$Companion_getInstance() {
    if (GomokuBoard$Companion_instance === null) {
      new GomokuBoard$Companion();
    }
    return GomokuBoard$Companion_instance;
  }
  GomokuBoard.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'GomokuBoard',
    interfaces: []
  };
  function GoGridStatus(gridIndex, gridClass) {
    this.gridIndex = gridIndex;
    this.gridClass = gridClass;
  }
  GoGridStatus.prototype.blackStone = function () {
    return equals(this.gridClass, 'blackCell');
  };
  GoGridStatus.prototype.whiteStone = function () {
    return equals(this.gridClass, 'whiteCell');
  };
  GoGridStatus.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'GoGridStatus',
    interfaces: []
  };
  function GameStatus(gridCells, gameFinishMessage, invalidMoveMessage) {
    this.gridCells = gridCells;
    this.gameFinishMessage = gameFinishMessage;
    this.invalidMoveMessage = invalidMoveMessage;
  }
  GameStatus.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'GameStatus',
    interfaces: []
  };
  function MainPageController() {
  }
  MainPageController.prototype.main = function () {
    var gridCells = ArrayList_init();
    for (var i = 0; i < 225; i++) {
      gridCells.add_11rb$(new GoGridStatus(i, 'emptyCell'));
    }
    return new GameStatus(gridCells, null, null);
  };
  MainPageController.prototype.getNewGame = function () {
    var gameController = new GameController(15, 5);
    return new GameStatus(this.getGridCellsFromGameController_2j27kp$(gameController), null, null);
  };
  MainPageController.prototype.getCOMBoardStatus_bm4lxs$ = function (gridState, lastBlackPosition) {
    var gameController = this.getGameControllerFromGridState_bm4lxs$(gridState, lastBlackPosition);
    if (gameController.explicitMoveAvailable()) {
      gameController.doMove();
    }
     else {
      var explorationCount = 2000;
      for (var i = 0; i < explorationCount; i++) {
        gameController.exploreMove_za3lpa$(-1);
      }
      gameController.doMove();
    }
    var gridCells = this.getGridCellsFromGameController_2j27kp$(gameController);
    var gStatus = new GameStatus(gridCells, null, null);
    this.checkGameFinish_vm2hon$(gameController, gStatus);
    return gStatus;
  };
  MainPageController.prototype.checkGameFinish_vm2hon$ = function (gameController, gameStatus) {
    if (gameController.isGameOver()) {
      if (gameController.scoring.checkWin_wr9i4e$(gameController.whiteBoard)) {
        gameStatus.gameFinishMessage = '\u3042\u306A\u305F(\u9ED2)\u306E\u8CA0\u3051\u3067\u3059';
      }
       else if (gameController.scoring.checkWin_wr9i4e$(gameController.blackBoard)) {
        gameStatus.gameFinishMessage = '\u3042\u306A\u305F\uFF08\u9ED2)\u306E\u52DD\u3061\u3067\u3059';
      }
       else {
        gameStatus.gameFinishMessage = '\u5F15\u304D\u5206\u3051';
      }
    }
  };
  MainPageController.prototype.getBoardStatus_19mbxw$ = function (playerMove, gridState) {
    var gameController = this.getGameControllerFromGridState_bm4lxs$(gridState);
    var playerStoneY = playerMove / 15 | 0;
    var playerStoneX = playerMove - (playerStoneY * 15 | 0) | 0;
    var playNotPossible = gameController.cannotPutBlackStone_vux9f0$(playerStoneX, playerStoneY);
    if (playNotPossible) {
      var gridCells = this.getGridCellsFromGameController_2j27kp$(gameController);
      var gStatus = new GameStatus(gridCells, null, '\u3053\u3053\u306B\u77F3\u306F\u7F6E\u3051\u307E\u305B\u3093(33)');
      this.checkGameFinish_vm2hon$(gameController, gStatus);
      return gStatus;
    }
    gameController.putBlackStone_vux9f0$(playerStoneX, playerStoneY);
    var gridCells_0 = this.getGridCellsFromGameController_2j27kp$(gameController);
    var gStatus_0 = new GameStatus(gridCells_0, null, null);
    this.checkGameFinish_vm2hon$(gameController, gStatus_0);
    return gStatus_0;
  };
  MainPageController.prototype.getGridCellsFromGameController_2j27kp$ = function (gController) {
    var gridStatus = ArrayList_init();
    for (var y = 0; y < 15; y++) {
      for (var x = 0; x < 15; x++) {
        var positionIndex = (y * 15 | 0) + x | 0;
        var status = gController.getStoneStatus_vux9f0$(x, y);
        if (status === 1) {
          gridStatus.add_11rb$(new GoGridStatus(positionIndex, 'blackCell'));
        }
         else if (status === 2) {
          gridStatus.add_11rb$(new GoGridStatus(positionIndex, 'whiteCell'));
        }
         else {
          gridStatus.add_11rb$(new GoGridStatus(positionIndex, 'emptyCell'));
        }
      }
    }
    return gridStatus;
  };
  MainPageController.prototype.getGameControllerFromGridState_bm4lxs$ = function (gridState, lastPositionIndex) {
    if (lastPositionIndex === void 0)
      lastPositionIndex = -1;
    var tmp$;
    var gController = new GameController(15, 5);
    var blackPositions = ArrayList_init();
    var whitePositions = ArrayList_init();
    for (var gridStateIndex = 0; gridStateIndex < 225; gridStateIndex++) {
      var stateChar = gridState.charCodeAt(gridStateIndex);
      if (stateChar === 98) {
        gController.blackBoard[gridStateIndex] = true;
        if (gridStateIndex !== lastPositionIndex)
          blackPositions.add_11rb$(gridStateIndex);
      }
       else if (stateChar === 119) {
        gController.whiteBoard[gridStateIndex] = true;
        if (gridStateIndex !== lastPositionIndex)
          whitePositions.add_11rb$(gridStateIndex);
      }
    }
    var stoneCount = whitePositions.size;
    if (stoneCount < blackPositions.size) {
      stoneCount = blackPositions.size;
    }
    tmp$ = stoneCount;
    for (var stoneIndex = 0; stoneIndex < tmp$; stoneIndex++) {
      if (stoneIndex < blackPositions.size) {
        gController.stonePositionHistory.add_11rb$(blackPositions.get_za3lpa$(stoneIndex));
      }
      if (stoneIndex < whitePositions.size) {
        gController.stonePositionHistory.add_11rb$(whitePositions.get_za3lpa$(stoneIndex));
      }
    }
    gController.stonePositionHistory.add_11rb$(lastPositionIndex);
    return gController;
  };
  MainPageController.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'MainPageController',
    interfaces: []
  };
  function Math_1() {
    Math$Companion_getInstance();
  }
  function Math$Companion() {
    Math$Companion_instance = this;
  }
  Math$Companion.prototype.log_14dthe$ = function (x) {
    return log(x, 2.718281828);
  };
  Math$Companion.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'Companion',
    interfaces: []
  };
  var Math$Companion_instance = null;
  function Math$Companion_getInstance() {
    if (Math$Companion_instance === null) {
      new Math$Companion();
    }
    return Math$Companion_instance;
  }
  Math_1.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'Math',
    interfaces: []
  };
  function GomokuRule(boardSize, winLength) {
    GomokuRule$Companion_getInstance();
    this.boardSize = boardSize;
    this.winLength = winLength;
  }
  GomokuRule.prototype.judge_35v2br$ = function (board) {
    return 1;
  };
  function GomokuRule$Companion() {
    GomokuRule$Companion_instance = this;
    this.WHITE_WIN = 1;
    this.BLACK_WIN = 2;
  }
  GomokuRule$Companion.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'Companion',
    interfaces: []
  };
  var GomokuRule$Companion_instance = null;
  function GomokuRule$Companion_getInstance() {
    if (GomokuRule$Companion_instance === null) {
      new GomokuRule$Companion();
    }
    return GomokuRule$Companion_instance;
  }
  GomokuRule.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'GomokuRule',
    interfaces: []
  };
  function TNLog() {
    TNLog$Companion_getInstance();
  }
  function TNLog$Companion() {
    TNLog$Companion_instance = this;
  }
  TNLog$Companion.prototype.i_puj7f4$ = function (tag, content) {
  };
  TNLog$Companion.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'Companion',
    interfaces: []
  };
  var TNLog$Companion_instance = null;
  function TNLog$Companion_getInstance() {
    if (TNLog$Companion_instance === null) {
      new TNLog$Companion();
    }
    return TNLog$Companion_instance;
  }
  TNLog.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'TNLog',
    interfaces: []
  };
  function Math_2() {
    Math$Companion_getInstance_0();
  }
  function Math$Companion_0() {
    Math$Companion_instance_0 = this;
  }
  Math$Companion_0.prototype.log_14dthe$ = function (x) {
    return log(x, 2.718281828);
  };
  Math$Companion_0.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'Companion',
    interfaces: []
  };
  var Math$Companion_instance_0 = null;
  function Math$Companion_getInstance_0() {
    if (Math$Companion_instance_0 === null) {
      new Math$Companion_0();
    }
    return Math$Companion_instance_0;
  }
  Math_2.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'Math',
    interfaces: []
  };
  var package$ktjs = _.ktjs || (_.ktjs = {});
  var package$gomoku = package$ktjs.gomoku || (package$ktjs.gomoku = {});
  Object.defineProperty(package$gomoku, 'pageController', {
    get: function () {
      return pageController;
    }
  });
  Object.defineProperty(package$gomoku, 'userInputReady', {
    get: function () {
      return userInputReady;
    },
    set: function (value) {
      userInputReady = value;
    }
  });
  package$gomoku.App = App;
  package$gomoku.requestCOMMoveUpdate = requestCOMMoveUpdate;
  package$gomoku.main_kand9s$ = main;
  package$gomoku.populateGoBoardHTML_turqji$ = populateGoBoardHTML;
  package$gomoku.getGameStatusNotificationHTMLContent_turqji$ = getGameStatusNotificationHTMLContent;
  package$gomoku.hookUserClickOnBoard = hookUserClickOnBoard;
  package$gomoku.hookEvents = hookEvents;
  package$gomoku.hookNewGameButton = hookNewGameButton;
  package$gomoku.getBoardState = getBoardState;
  Object.defineProperty(GameController, 'Companion', {
    get: GameController$Companion_getInstance
  });
  var package$com = _.com || (_.com = {});
  var package$jwechrs = package$com.jwechrs || (package$com.jwechrs = {});
  var package$simplegomokugame = package$jwechrs.simplegomokugame || (package$jwechrs.simplegomokugame = {});
  package$simplegomokugame.GameController = GameController;
  Object.defineProperty(GameScoring, 'Companion', {
    get: GameScoring$Companion_getInstance
  });
  package$simplegomokugame.GameScoring = GameScoring;
  package$simplegomokugame.StoneSequence = StoneSequence;
  Object.defineProperty(GomokuBoard, 'Companion', {
    get: GomokuBoard$Companion_getInstance
  });
  package$simplegomokugame.GomokuBoard = GomokuBoard;
  package$gomoku.GoGridStatus = GoGridStatus;
  package$gomoku.GameStatus = GameStatus;
  package$gomoku.MainPageController = MainPageController;
  Object.defineProperty(Math_1, 'Companion', {
    get: Math$Companion_getInstance
  });
  var package$mathbridge = package$jwechrs.mathbridge || (package$jwechrs.mathbridge = {});
  package$mathbridge.Math = Math_1;
  Object.defineProperty(GomokuRule, 'Companion', {
    get: GomokuRule$Companion_getInstance
  });
  package$simplegomokugame.GomokuRule = GomokuRule;
  Object.defineProperty(TNLog, 'Companion', {
    get: TNLog$Companion_getInstance
  });
  var package$touchlessgesture = package$jwechrs.touchlessgesture || (package$jwechrs.touchlessgesture = {});
  var package$common = package$touchlessgesture.common || (package$touchlessgesture.common = {});
  package$common.TNLog = TNLog;
  Object.defineProperty(Math_2, 'Companion', {
    get: Math$Companion_getInstance_0
  });
  package$common.Math = Math_2;
  pageController = new MainPageController();
  userInputReady = true;
  main([]);
  Kotlin.defineModule('ktjs-gomoku', _);
  return _;
}));

//# sourceMappingURL=ktjs-gomoku.js.map
