/*
 * This Kotlin source file was generated by the Gradle 'init' task.
 */
package ktjs.gomoku
import kotlin.browser.document
import kotlin.browser.window
import kotlin.js.Promise
import org.w3c.dom.HTMLElement
import org.w3c.dom.HTMLCollection

val pageController = MainPageController()
var userInputReady = true

class App {
    val greeting: String
        get() {
            return "Hello world."
        }
}

fun requestCOMMoveUpdate(){
    val boardState = getBoardState()
}

fun main(args: Array<String>) {
    populateGoBoardHTML(pageController.main())
    hookUserClickOnBoard();
    hookNewGameButton()
    //println(App().greeting)
}

fun populateGoBoardHTML(gameStatus: GameStatus){
    var gridHTML = ""
    for(gridIndex in 0 until 15*15){
        val gridClass = gameStatus.gridCells[gridIndex].gridClass
        val stoneImage: String? = if (gridClass== "emptyCell") {
            null
        } else if (gridClass == "blackCell"){
            "images/black_circle.png"
        } else if (gridClass == "whiteCell"){
            "images/white_circle.png"
        } else {
            null
        }
        gridHTML += "<div id='${gridIndex}' class='${gridClass}'>"
        stoneImage?.let {
            gridHTML += "  <span class='stoneImageFrame'>"
            gridHTML += "    <img class='stoneImage' src='${it}' alt='${gridClass}'>"
            gridHTML += "  </span>"
        }
        gridHTML += "</div>"
    }
    (document.getElementById("gridContainer") as HTMLElement).innerHTML = gridHTML
    (document.getElementById("blackTurn") as HTMLElement).style.display = if (userInputReady){
        "block"
    } else {
        "none"
    }

    (document.getElementById("gameStatusNotification") as HTMLElement).innerHTML = getGameStatusNotificationHTMLContent(gameStatus)
    //println("populate done")
    //hookUserClickOnBoard()
}

fun getGameStatusNotificationHTMLContent(gameStatus: GameStatus): String {
    gameStatus.gameFinishMessage?.let {
        var htmlContent = ""
        htmlContent = "<div class='alert alert-info col-md-12' id='gameFinishNotification'>"
        htmlContent += "${it}&nbsp;&nbsp;<a href='#' class='newGameButton alert-link'>新しいゲームを開始</a>"
        htmlContent += "</div>"
        return htmlContent
    }
    gameStatus.invalidMoveMessage?.let{
        var htmlContent = ""
        htmlContent += "<div class='alert alert-warning col-md-12' id='moveNotValidNotification'>"
        htmlContent += "${it}"
        htmlContent += "</div>"
        return htmlContent
    }
    return ""
}

fun hookUserClickOnBoard(){
    for(gridIndex in 0 until 15*15){
        //println("hooking")
        (document.getElementById("${gridIndex}")as HTMLElement).addEventListener(
            "click",
            {event ->
                 //println("click!")
             if (document.getElementById("gameFinishNotification") != null){
                 window.alert("ゲームは終わっています")
             }
             else if (!userInputReady){
                 window.alert("白の手番です")
             }
             else if (!(document.getElementById("${gridIndex}")as HTMLElement).classList.contains("emptyCell")){
                 //alert("not empty!")
                 //throw RuntimeException("not empty!")
                 //println("not empty")
             } else if (!userInputReady){
                 //println("not empty")
             } else {
                 userInputReady = false
                 val newGameStatus = pageController.getBoardStatus(gridIndex, getBoardState())
                 //println("game update")
                 populateGoBoardHTML(newGameStatus)
                 //hookUserClickOnBoard()
                 hookNewGameButton()
                 if (newGameStatus.gameFinishMessage != null){
                     // ゲーム終了
                 } else if (newGameStatus.invalidMoveMessage != null){
                     // 反則
                     userInputReady = true
                     hookEvents()
                 } else {
                     val boardState = getBoardState()
                 // class RequestCOMMoveThread: Thread(){
                     //     public override fun run(){
                         //         val comGameStatus = pageController.getCOMBoardStatus(boardState, gridIndex)
                         //         println("COM move udpate")
                         //         populateGoBoardHTML(comGameStatus)
                         //         userInputReady = true
                         //         hookUserClickOnBoard()
                         //     }
                         // }
                         // val requestComThread = RequestCOMMoveThread()
                         // requestComThread.start()
                         //println("start preparing")
                         val comMove = Promise<GameStatus>(
                             {resolve, reject ->
                                  window.setTimeout(
                                      handler={
                                          val comStatus = pageController.getCOMBoardStatus(boardState, gridIndex)
                                          //populateGoBoardHTML(comStatus)
                                          resolve(comStatus)
                                      },
                                      timeout=500
                                  )

                              //comStatus
                         })
                         comMove.then({resultValue ->
                                      //println("com OK")
                                  userInputReady = true
                                  populateGoBoardHTML(resultValue)
                                  hookUserClickOnBoard()
                                  hookNewGameButton()
                         })
                         //println("waiting for com")
                 }
             }
        })
    }
}


fun hookEvents(){
    hookUserClickOnBoard()
    hookNewGameButton()
}

fun hookNewGameButton(){
    var newgameButtons = (document.getElementsByClassName("newGameButton") as HTMLCollection)
    // for (buttonIndex in 0 until newgameButtons.size){
    //     val newGameButton = (newgameButtons[buttonIndex] as HTMLElement)
    //     newGameButton.addEventListener(
    //         "click",
    //         {
    //             val newGameBoardState = pageController.getNewGame()
    //             populateGoBoardHTML(newGameBoardState)
    //         }
    //     )
    // }
    var objectIndex = 0;
    while (true) {
        val buttonItem = newgameButtons.item(objectIndex)
        if (buttonItem == null){
            break
        } else {
            buttonItem.addEventListener(
                        "click",
                        {
                                val newGameBoardState = pageController.getNewGame()
                                populateGoBoardHTML(newGameBoardState)
                                userInputReady = true
                                hookEvents()
                            }
            )
            objectIndex ++
        }
    }
}

fun getBoardState(): String {
    val gridStatus = ArrayList<String>();
    for(gridIndex in 0 until 15 * 15){
        val gridObject = document.getElementById("${gridIndex}") as HTMLElement
        if (gridObject.classList.contains("emptyCell")){
            gridStatus.add("e")
        } else if (gridObject.classList.contains("blackCell")){
            gridStatus.add("b")
        } else if (gridObject.classList.contains("whiteCell")){
            gridStatus.add("w")
        } else {
            throw RuntimeException("??")
        }
    }
    return gridStatus.joinToString(separator="")
}
