package com.jwechrs.simplegomokugame
import com.jwechrs.mathbridge.Math

//ignored by js --> import java.lang.RuntimeException

class GameScoring(val boardSize: Int, val winSequenceCount: Int) {

    fun check33(boardArray: BooleanArray, otherPlayerBoard: BooleanArray,
    focusPositionIndex: Int = -1): Boolean {
        // 33があるか確認
        val directions = ArrayList<IntArray>()
        directions.add(intArrayOf(1, 0))
        directions.add(intArrayOf(1, 1))
        directions.add(intArrayOf(0, 1))
        directions.add(intArrayOf(-1,1))
//        directions.add(intArrayOf(-1,0))
//        directions.add(intArrayOf(-1,-1))
//        directions.add(intArrayOf(0,-1))
//        directions.add(intArrayOf(1,-1))
        val threeCount = IntArray(boardSize * boardSize)
        for(x in 0 until boardSize){
            for(y in 0 until boardSize){
                if (boardArray[x + y * boardSize]){
                    var threeConsequtiveCount = 0
                    val positionIndex = x + y * boardSize
                    for (direction in directions){
                        if (checkConsequtiveStonesInDirection(
                                boardSize,
                                boardArray, x, y, direction[0], direction[1],
                                checkBedinnning = true,
                                checkEnd = true,
                                repeat = 3,
                                missingTorelance = 0,
                                otherPlayerBoard = otherPlayerBoard
                            )){
                            // 3が止められていないか確認
                            if (!positionOnBoard(x-direction[0],y-direction[1], boardSize) || !positionOnBoard(x + 3 * direction[0], y+3 *direction[1], boardSize)){
                                // 3は端
                                continue
                            }
                            if (otherPlayerBoard[(x-direction[0] + (y- direction[1]) * boardSize)] ||
                                    otherPlayerBoard[(x+3 * direction[0]) + (y+3 * direction[1]) * boardSize]){
                                // 3はとめられている
                                continue
                            }
//                            threeConsequtiveCount ++
//                            if (threeConsequtiveCount >= 2){
//                                return true
//                            }
                            //threeCount[positionIndex] ++
                            for(i in 0 until 3){
                                val sequenceX = x + i * direction[0]
                                val sequenceY = y + i * direction[1]
                                threeCount[sequenceX + sequenceY * boardSize] ++
                            }
//                            if (threeCount[positionIndex] >= 2){
//                                return true
//                            }


                        } else if (checkConsequtiveStonesInDirection(
                                boardSize,
                                boardArray, x, y, direction[0], direction[1],
                                checkBedinnning = true,
                                checkEnd = true,
                                repeat = 4,
                                missingTorelance = 1,
                                otherPlayerBoard = otherPlayerBoard
                            )) {
                            if (checkConsequtiveStonesInDirection(
                                    boardSize, boardArray, x, y, direction[0], direction[1],
                                    checkBedinnning = true,
                                    checkEnd = true, repeat = 4,
                                    missingTorelance = 0,
                                    otherPlayerBoard = otherPlayerBoard
                                )){
                                // 飛ばしなしの4連続 --> 無視
                                continue
                            }
                            // 3が止められていないか確認
                            if (!positionOnBoard(
                                    x - direction[0],
                                    y - direction[1],
                                    boardSize
                                ) || !positionOnBoard(
                                    x + 4 * direction[0],
                                    y + 4 * direction[1],
                                    boardSize
                                )
                            ) {
                                // 3は端
                                continue
                            }
                            if (otherPlayerBoard[(x - direction[0] + (y - direction[1]) * boardSize)] ||
                                otherPlayerBoard[(x + 4 * direction[0]) + (y + 4 * direction[1]) * boardSize]
                            ) {
                                // 3はとめられている
                                continue
                            }
//                            threeConsequtiveCount++
//                            if (threeConsequtiveCount >= 2) {
//                                return true
//                            }
                            //threeCount[positionIndex] ++
                            for(i in 0 until 4){
                                val sequenceX = x + i * direction[0]
                                val sequenceY = y + i * direction[1]
                                if (!boardArray[sequenceX + sequenceY * boardSize]){
                                    continue
                                }
                                if (otherPlayerBoard[sequenceX + sequenceY * boardSize]){
                                    throw RuntimeException("otherboard not empty!")
                                }
                                threeCount[sequenceX + sequenceY * boardSize] ++
                            }
//                            if (threeCount[positionIndex] >= 2){
//                                return true
//                            }
                        }

                    }
                }
            }
        }
        if (focusPositionIndex >= 0){
            return threeCount[focusPositionIndex] >= 2
        }
        for(x in 0 until boardSize){
            for(y in 0 until boardSize){
                if (threeCount[x + y * boardSize] >= 2){
                    return true
                }
            }
        }
        return false
    }
    fun checkLose(boardArray: BooleanArray, otherPlayerBoard: BooleanArray,
    lastStoneIndex: Int): Boolean {
        // 33があるとまけ
        if (check33(boardArray, otherPlayerBoard, lastStoneIndex)){
            return true
        }
        return false
    }
    fun checkWin(boardArray: BooleanArray): Boolean{
        for(x in 0 until boardSize){
            for(y in 0 until boardSize) {
                if (boardArray[x + y * boardSize]){
                    if (checkConsequtiveStonesInDirection(
                            boardSize,
                            boardArray,
                            x, y, 1, 0,
                            winSequenceCount,
                            checkBedinnning = true
                        )){
                        return true
                    }
                    if (checkConsequtiveStonesInDirection(
                            boardSize,
                            boardArray,
                            x, y, 1, 1,
                            winSequenceCount,
                            checkBedinnning = true
                        )){
                        return true
                    }
                    if (checkConsequtiveStonesInDirection(
                            boardSize,
                            boardArray,
                            x, y, 0, 1,
                            winSequenceCount,
                            checkBedinnning = true
                        )){
                        return true
                    }
                    if (checkConsequtiveStonesInDirection(
                            boardSize,
                            boardArray,
                            x, y, -1, 1,
                            winSequenceCount,
                            checkBedinnning = true
                        )){
                        return true
                    }
                }
            }
        }
        return false
    }
    fun gameDraw(whiteBoard: BooleanArray, blackBoard: BooleanArray): Boolean{
        for(i in 0 until boardSize*boardSize){
            //if (!whiteBoard[i]){return false}
            //if (!blackBoard[i]){return false}
            if ((!blackBoard[i]) && (!whiteBoard[i])){
                return false
            }
        }
        return true
    }
    companion object {
        fun positionOnBoard(x: Int, y: Int, boardSize: Int): Boolean{
            return (x >= 0 && y >= 0 && x < boardSize && y < boardSize)
        }
        fun checkConsequtiveStonesInDirection(
            boardSize: Int,
            boardArray: BooleanArray,
            startX: Int, startY: Int, directionX: Int, directionY: Int, repeat: Int,
            checkBedinnning: Boolean = false,
            checkEnd: Boolean = true,
            missingTorelance: Int = 0,
            otherPlayerBoard: BooleanArray? = null): Boolean{
            // checkend: trueなら続きがないことを確認
            // checkBedinning: Trueなら一つ前に同じ石がないことを確認 (最初の石だけ確認)
            if (repeat == 0){
                if (checkEnd){
                    if (startX >= 0 && startY >= 0 && startX < boardSize && startY < boardSize){
                        //
                        if (boardArray[startX + startY * boardSize]){
                            //repeat以上つづいている
                            return false
                        } else {
                            otherPlayerBoard?.let {
                                if (it[startY + startY * boardSize]){
                                    return false
                                }
                            }
                            return true
                        }
                    } else {
                        return true
                    }
                }
                return true
            }
            if (startX >= boardSize || startY >= boardSize || startX < 0 ||startY < 0){
                return false
            }
            if (checkBedinnning){
                val previousX = startX - directionX
                val previousY = startY -directionY
                if (previousX >= 0 && previousY >= 0 && previousX < boardSize && previousY < boardSize){
                    if (boardArray[previousX + previousY * boardSize]){
                        return false
                    }
                    otherPlayerBoard?.let {
                        if (it[previousX + previousY * boardSize]){
                            return false
                        }
                    }
                }
            }
            if (missingTorelance == 0){
                return if (!boardArray[startX + startY * boardSize]){
                    false
                } else {
                    checkConsequtiveStonesInDirection(
                        boardSize,
                        boardArray,
                        startX + directionX,
                        startY + directionY,
                        directionX, directionY,
                        repeat-1,
                        checkBedinnning=false,
                        checkEnd=checkEnd
                    )
                }
            } else {
                if (!boardArray[startX  + startY * boardSize]){

                    otherPlayerBoard?.let {
                        if (it[startX + startY * boardSize]){
                            //　隙間に相手の石がある
                            return false
                        }
                    }
                    return checkConsequtiveStonesInDirection(
                        boardSize,
                        boardArray,
                        startX + directionX,
                        startY + directionY,
                        directionX, directionY,
                        repeat-1,
                        checkBedinnning = false,
                        checkEnd = checkEnd,
                        missingTorelance = missingTorelance-1,
                        otherPlayerBoard = otherPlayerBoard
                    )
                } else {
                    return checkConsequtiveStonesInDirection(
                        boardSize,
                        boardArray,
                        startX + directionX,
                        startY + directionY,
                        directionX, directionY,
                        repeat-1,
                        checkBedinnning=false,
                        checkEnd=checkEnd,
                        missingTorelance = missingTorelance,
                        otherPlayerBoard = otherPlayerBoard
                    )
                }
            }

        }
    }

}
